import { AdvanceTreeSelectionProps } from './index';
import { ListType, TreeData } from '../base-tree-selection';
import { Env } from '../../tree-selection';
type AdvanceTreeSelectionHook = Omit<AdvanceTreeSelectionProps, 'getEmployeeOrdepartmentTree'>;
declare const useSelectTree: (props: AdvanceTreeSelectionHook) => {
    visible: boolean;
    onCancelSubmit: (visible: boolean) => void;
    onSubmitSuccess: (success: boolean, values: any) => void;
    onSelectChange: (values: {
        label: string;
        value: string;
    }[]) => void;
    renderMultipleSelectOrSelect: (isMultiple?: boolean) => JSX.Element;
    onChange: (nodes: TreeData[]) => void;
    getSearchResultByname: (name: string, env?: any) => Promise<Response>;
    hasSelectedKeys: TreeData[];
};
declare const useGetTreeDateAndRootId: (getEmployeeOrdepartmentTree: (data?: any) => Promise<any>, listType: ListType, isMultiple: boolean, env: Env) => any[];
export { useSelectTree, useGetTreeDateAndRootId };
