"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.traverseKeys = exports.transformArryToMap = exports.generateMapfromArray = exports.flattenTreeData = exports.filterTreeKeys = exports.addKeyByArrayMap = void 0;
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
// 将树扁平化
var flattenTreeData = function flattenTreeData(data, arr) {
  var cloneData = JSON.parse(JSON.stringify(data));
  if (!Array.isArray(data)) return [];
  return cloneData.reduce(function (prev, next) {
    prev.push(next);
    var children = next.children;
    if (Array.isArray(children)) {
      flattenTreeData(children, arr);
    }
    return arr;
  }, arr);
};
// 将数组变成map
exports.flattenTreeData = flattenTreeData;
var transformArryToMap = function transformArryToMap(arrs) {
  var treeDataMap = new Map();
  arrs.forEach(function (data) {
    var id = data.id;
    if (!id) return;
    if (treeDataMap.has(id)) {
      var datas = treeDataMap.get(id);
      if (!datas) return;
      datas.push(data);
      treeDataMap.set(id, datas);
    } else {
      treeDataMap.set(id, [data]);
    }
  });
  return treeDataMap;
};
exports.transformArryToMap = transformArryToMap;
var filterTreeKeys = function filterTreeKeys(key, map) {
  if (typeof key !== 'string') return [];
  var arr = key.split('_');
  return map.get(arr.length === 2 ? arr[1] : arr[0]);
};
// 将所有符合条件的数据放入数组中
exports.filterTreeKeys = filterTreeKeys;
var traverseKeys = function traverseKeys(keys, map) {
  var arr = [];
  keys.forEach(function (key) {
    arr = arr.concat(filterTreeKeys(key, map));
  });
  // 数据进行去重
  return Array.from(new Set(arr)).map(function (item) {
    return item.key;
  });
};
// 将数组转化为map
exports.traverseKeys = traverseKeys;
var generateMapfromArray = function generateMapfromArray(array) {
  var map = new Map();
  array.filter(function (item) {
    return item.isLeaf;
  }).forEach(function (item) {
    var id = item.id;
    map.set(id, item);
  });
  return map;
};
exports.generateMapfromArray = generateMapfromArray;
var addKeyByArrayMap = function addKeyByArrayMap(list, isEmployee) {
  return list.map(function (item) {
    return _objectSpread(_objectSpread({}, item), {}, {
      key: item.id,
      title: item.name,
      isEmployee: isEmployee
    });
  });
};
exports.addKeyByArrayMap = addKeyByArrayMap;